//### This file created by BYACC 1.8(/Java extension  1.13)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//###           04 Mar 02  -- Yuval Oren  -- improved java performance, added options
//###           14 Mar 02  -- Tomas Hurka -- -d support, static initializer workaround
//### Please send bug reports to tom@hukatronic.cz
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package com.thoughtworks.qdox.parser.impl;



//#line 2 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
import com.thoughtworks.qdox.parser.*;
import com.thoughtworks.qdox.parser.structs.*;
import com.thoughtworks.qdox.model.*;
import com.thoughtworks.qdox.model.annotation.*;
import java.io.IOException;
import java.util.LinkedList;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
//#line 27 "Parser.java"




public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[] = new int[YYSTACKSIZE]; //state stack
int stateptr;
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
final void state_push(int state)
{
  try {
		stateptr++;
		statestk[stateptr]=state;
	 }
	 catch (ArrayIndexOutOfBoundsException e) {
     int oldsize = statestk.length;
     int newsize = oldsize * 2;
     int[] newstack = new int[newsize];
     System.arraycopy(statestk,0,newstack,0,oldsize);
     statestk = newstack;
     statestk[stateptr]=state;
  }
}
final int state_pop()
{
  return statestk[stateptr--];
}
final void state_drop(int cnt)
{
  stateptr -= cnt; 
}
final int state_peek(int relative)
{
  return statestk[stateptr-relative];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
final boolean init_stacks()
{
  stateptr = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//## **user defined:Value
String   yytext;//user variable to return contextual strings
Value yyval; //used to return semantic vals from action routines
Value yylval;//the 'lval' (result) I got from yylex()
Value valstk[] = new Value[YYSTACKSIZE];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
final void val_init()
{
  yyval=new Value();
  yylval=new Value();
  valptr=-1;
}
final void val_push(Value val)
{
  try {
    valptr++;
    valstk[valptr]=val;
  }
  catch (ArrayIndexOutOfBoundsException e) {
    int oldsize = valstk.length;
    int newsize = oldsize*2;
    Value[] newstack = new Value[newsize];
    System.arraycopy(valstk,0,newstack,0,oldsize);
    valstk = newstack;
    valstk[valptr]=val;
  }
}
final Value val_pop()
{
  return valstk[valptr--];
}
final void val_drop(int cnt)
{
  valptr -= cnt;
}
final Value val_peek(int relative)
{
  return valstk[valptr-relative];
}
//#### end semantic value section ####
public final static short SEMI=257;
public final static short DOT=258;
public final static short DOTDOTDOT=259;
public final static short COMMA=260;
public final static short STAR=261;
public final static short PERCENT=262;
public final static short EQUALS=263;
public final static short ANNOSTRING=264;
public final static short ANNOCHAR=265;
public final static short SLASH=266;
public final static short PLUS=267;
public final static short MINUS=268;
public final static short PACKAGE=269;
public final static short IMPORT=270;
public final static short PUBLIC=271;
public final static short PROTECTED=272;
public final static short PRIVATE=273;
public final static short STATIC=274;
public final static short FINAL=275;
public final static short ABSTRACT=276;
public final static short NATIVE=277;
public final static short STRICTFP=278;
public final static short SYNCHRONIZED=279;
public final static short TRANSIENT=280;
public final static short VOLATILE=281;
public final static short CLASS=282;
public final static short INTERFACE=283;
public final static short ENUM=284;
public final static short ANNOINTERFACE=285;
public final static short THROWS=286;
public final static short EXTENDS=287;
public final static short IMPLEMENTS=288;
public final static short SUPER=289;
public final static short DEFAULT=290;
public final static short BRACEOPEN=291;
public final static short BRACECLOSE=292;
public final static short SQUAREOPEN=293;
public final static short SQUARECLOSE=294;
public final static short PARENOPEN=295;
public final static short PARENCLOSE=296;
public final static short LESSTHAN=297;
public final static short GREATERTHAN=298;
public final static short LESSEQUALS=299;
public final static short GREATEREQUALS=300;
public final static short LESSTHAN2=301;
public final static short GREATERTHAN2=302;
public final static short GREATERTHAN3=303;
public final static short EXCLAMATION=304;
public final static short AMPERSAND2=305;
public final static short VERTLINE2=306;
public final static short EQUALS2=307;
public final static short NOTEQUALS=308;
public final static short TILDE=309;
public final static short AMPERSAND=310;
public final static short VERTLINE=311;
public final static short CIRCUMFLEX=312;
public final static short VOID=313;
public final static short QUERY=314;
public final static short COLON=315;
public final static short AT=316;
public final static short JAVADOCSTART=317;
public final static short JAVADOCEND=318;
public final static short JAVADOCEOL=319;
public final static short CODEBLOCK=320;
public final static short PARENBLOCK=321;
public final static short BYTE=322;
public final static short SHORT=323;
public final static short INT=324;
public final static short LONG=325;
public final static short CHAR=326;
public final static short FLOAT=327;
public final static short DOUBLE=328;
public final static short BOOLEAN=329;
public final static short IDENTIFIER=330;
public final static short JAVADOCTAG=331;
public final static short JAVADOCTOKEN=332;
public final static short BOOLEAN_LITERAL=333;
public final static short INTEGER_LITERAL=334;
public final static short LONG_LITERAL=335;
public final static short FLOAT_LITERAL=336;
public final static short DOUBLE_LITERAL=337;
public final static short CHAR_LITERAL=338;
public final static short STRING_LITERAL=339;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,   35,    0,   34,   34,   34,   34,   34,   34,   36,
   37,   37,   38,   41,   43,   43,   44,   44,   42,   42,
   46,   45,   23,   23,   23,   31,   28,   28,   24,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   47,
   47,   47,   49,    6,   48,   48,   48,   48,   50,   50,
   51,   52,    7,   53,   53,   54,   54,    3,    3,    3,
    4,    8,    8,    9,    9,   10,   10,   11,   11,   12,
   12,   13,   13,   14,   14,   14,   15,   15,   15,   15,
   15,   16,   16,   16,   16,   17,   17,   17,   18,   18,
   18,   18,   19,   19,   19,   20,   20,   20,   21,   21,
   21,   21,   21,   21,   21,   21,   21,   21,   21,   22,
   22,    1,    1,    5,    5,    5,    5,    5,    5,    5,
    2,    2,    2,    2,    2,    2,    2,    2,   30,   56,
   57,   32,   32,   25,   25,   26,   26,   55,   55,   33,
   33,   33,   33,   58,   58,   59,   60,   60,   61,   61,
   62,   62,   40,   63,   64,   64,   66,   66,   66,   68,
   68,   69,   69,   69,   69,   39,   71,   72,   72,   72,
   73,   73,   74,   74,   65,   65,   75,   75,   67,   77,
   67,   76,   76,   76,   76,   76,   76,   76,   76,   27,
   27,   81,   83,   78,   82,   84,   82,   79,   79,   80,
   85,   86,   86,   88,   88,   87,   87,   89,   89,   90,
   29,   29,   70,   70,   91,   91,
};
final static short yylen[] = {                            2,
    0,    0,    3,    1,    1,    1,    1,    1,    1,    3,
    3,    4,    4,    1,    0,    2,    1,    1,    0,    2,
    0,    3,    1,    3,    3,    2,    0,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    2,    0,    0,    4,    0,    3,    3,    2,    1,    3,
    3,    0,    4,    0,    1,    1,    3,    1,    1,    1,
    1,    1,    5,    1,    3,    1,    3,    1,    3,    1,
    3,    1,    3,    1,    3,    3,    1,    3,    3,    3,
    3,    1,    3,    3,    3,    1,    3,    3,    1,    3,
    3,    3,    2,    2,    1,    2,    2,    1,    4,    5,
    5,    4,    3,    1,    4,    3,    3,    4,    1,    2,
    3,    1,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    0,
    0,    6,    1,    1,    3,    1,    3,    1,    3,    1,
    1,    3,    3,    0,    1,    3,    1,    3,    1,    3,
    1,    3,    4,    4,    1,    3,    0,    1,    3,    2,
    2,    1,    2,    2,    3,    4,    6,    1,    1,    1,
    0,    2,    1,    3,    0,    2,    1,    3,    0,    0,
    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    0,    6,    0,    0,    4,    8,    7,    5,
    3,    0,    2,    1,    3,    0,    1,    1,    3,    5,
    0,    1,    0,    2,    0,    2,
};
final static short yydefred[] = {                         1,
    2,    0,    9,    0,    0,   15,    3,    4,    5,    6,
    7,    8,    0,    0,    0,   23,    0,    0,    0,   19,
    0,   29,   30,   31,   32,   33,   34,   35,   39,   36,
   38,   37,  168,  169,    0,  170,    0,   41,   40,    0,
    0,  179,   10,    0,    0,   11,    0,   18,   17,   16,
    0,  112,    0,    0,    0,    0,    0,    0,    0,    0,
   25,   24,   12,   13,   21,   20,    0,  154,    0,    0,
    0,    0,  145,    0,  160,  153,  179,    0,  214,  161,
  166,    0,   15,  136,    0,    0,    0,    0,  113,    0,
   44,    0,    0,  147,    0,    0,  163,    0,    0,  159,
  189,  182,  187,  188,    0,  181,  183,  184,  185,  186,
    0,  130,    0,    0,    0,    0,    0,    0,   48,    0,
    0,  122,  123,  124,  125,  126,  127,  128,  121,    0,
  118,  117,  116,  115,  114,  119,  120,    0,    0,    0,
   58,  104,   59,   60,   61,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   89,   95,   98,    0,   49,
    0,    0,    0,  146,    0,    0,  167,  165,  192,    0,
    0,    0,    0,    0,  137,  135,    0,   93,   94,    0,
    0,    0,   97,   96,    0,    0,    0,    0,    0,    0,
   46,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   47,    0,  151,    0,  148,    0,    0,    0,
    0,  193,    0,    0,    0,  140,  138,    0,    0,    0,
    0,    0,  103,   51,  107,  110,    0,    0,  106,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   90,   92,   91,
    0,   50,   56,    0,    0,    0,    0,    0,    0,    0,
  208,    0,    0,    0,   27,  195,    0,    0,    0,    0,
    0,    0,  102,    0,   99,    0,  108,  111,  105,    0,
   53,    0,  152,    0,  201,  213,    0,    0,  190,  191,
  200,    0,    0,   28,   27,  142,  143,  139,  132,  101,
  100,   63,   57,  216,    0,  209,    0,    0,  196,  194,
    0,  212,    0,    0,  199,    0,    0,   27,  210,  197,
  198,
};
final static short yydgoto[] = {                          1,
  138,  139,  140,  141,  142,  143,  144,  145,  146,  147,
  148,  149,  150,  151,  152,  153,  154,  155,  156,  157,
  158,  188,   17,   39,   85,   86,  301,  274,  323,  226,
  222,  172,  227,    7,    2,    8,    9,   55,   11,   12,
   20,   47,   21,   50,   66,   83,   13,   91,   70,  159,
  160,  161,  264,  265,  228,  174,  282,   72,   73,   93,
   94,  216,   14,   56,   68,   57,   60,   58,   75,   59,
   15,   40,   96,  166,   88,  106,   82,  107,  108,  109,
  110,  303,  276,  326,  220,  273,  269,  298,  270,  271,
  294,
};
final static short yysindex[] = {                         0,
    0, -109,    0, -273, -246,    0,    0,    0,    0,    0,
    0,    0,  824, -189,  -82,    0,  -22, -273,   67,    0,
 -183,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -113,    0,  -35,    0,    0,   22,
   -9,    0,    0, -240,  173,    0,  -78,    0,    0,    0,
 -180,    0,   98,   62,   40,  103,  140,  142,  -23,  108,
    0,    0,    0,    0,    0,    0,  133,    0,  134,  143,
  154,  164,    0,   58,    0,    0,    0,   -9,    0,    0,
    0, -231,    0,    0,  189,  230,  231,  227,    0,  -52,
    0,  203, -233,    0,  133, -180,    0,  171,    0,    0,
    0,    0,    0,    0,  -51,    0,    0,    0,    0,    0,
 -183,    0,  162,  165,  133,   38,   38,   38,    0,   38,
   38,    0,    0,    0,    0,    0,    0,    0,    0,  233,
    0,    0,    0,    0,    0,    0,    0,  -45,  -44,  198,
    0,    0,    0,    0,    0, -245,  192,  187,  199,  204,
  119,   46,  121,  190,  137,    0,    0,    0, -224,    0,
  222,  133,  154,    0,  231,  255,    0,    0,    0,  223,
  191,  231,  133, -279,    0,    0,  231,    0,    0, -140,
  -86,  221,    0,    0,   -7, -251,  225,  -13,  238,    5,
    0,   38,   38,   38,   38,   38,   38,   38,   38,   38,
   38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
   38,  193,    0,   -7,    0,  214,    0,  133,    0,  239,
  223,    0,  245,  209,   49,    0,    0,  281,  834,  -46,
   38,   -4,    0,    0,    0,    0,  260,  251,    0,  264,
  192,  232,  187,  199,  204,  119,   46,   46,  121,  121,
  121,  121,  190,  190,  190,  137,  137,    0,    0,    0,
  233,    0,    0,  259,  292,  133,  231,  237,  261,  295,
    0, -273, -239,  245,    0,    0,  266,  223,  133,  133,
 -279,  258,    0,  834,    0,   38,    0,    0,    0,   38,
    0,   -7,    0,  229,    0,    0,  304,  301,    0,    0,
    0,   48, -238,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  307,    0, -273, -239,    0,    0,
   48,    0,  267,  304,    0,  267, -239,    0,    0,    0,
    0,
};
final static short yyrindex[] = {                         0,
    0,  839,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -27,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -242,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  316,    0,  109,   23,    0,    0,  306,    9,    0,  -79,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  136,
    0, -133,    0,   -2,    0,    0,    0, -242,    0,    0,
    0,  196,    0,    0, -235, -146, -200,  325,    0,  330,
    0, -222,    0,    0,    0,  316,    0,    2, -151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -18,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  282,
    0,    0,    0,    0,    0,    0,    0,  303,    0,    0,
    0,    0,    0,    0,    0, -153,  730,  709,  681,  331,
  262, -125,  520,  401,  352,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -49, -118,    0,    0,    0, -229,
    0, -227,    0,    0,    0,    0,  -72,    0,    0,  780,
    0,    0,    0,    0,  330,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  168,    0, -148,    0,    0,  169, -209,
 -220,    0, -243,    0, -144,    0,    0,  324,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  747,    0,  714,  697,  670,  653,   43,  632,  548,  569,
  590,  611,  450,  471,  499,  373,  422,    0,    0,    0,
    0,    0,    0,    0,  332,    0,    8,  256,    0,  329,
    0,    0,    0, -216,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  330,    0,    0,    0,    0, -215, -205,    0,    0,
    0, -209,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  296,    0,    0,    0,    0,    0,
 -209,    0,    0, -211,    0,    0,    0,    0,    0,    0,
    0,
};
final static short yygindex[] = {                         0,
  -26,  510, -175, -115,    0,  -12,    0,    0,    0,  437,
  436,  439,  435,  438,  263,  234,  249,  275, -112, -199,
    0,  -43,   -5,  338,    0,    0, -159, -165,    0, -103,
   14,  -61,  357,    0,    0,    0,    0,   12,  557,  565,
    0,    0,  573,    0,    0,    0,  586,    0,    0,    0,
  465,    0,    0,    0,    0,    0,    0,    0,  581,    0,
  528,    0,    0,    0,  596,  616,  618,    0,  637, -207,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -201, -259,    0,    0,    0,  409,
    0,
};
final static int YYTABLESIZE=1173;
static short yytable[];
static { yytable();}
static void yytable(){
yytable = new short[]{                         19,
   38,  171,  182,  178,  179,   87,  223,  183,  184,  234,
   53,  268,   45,   10,  157,  129,  129,  299,  299,  275,
   61,  319,  133,  133,  133,  101,  163,   18,  136,  283,
  235,   27,   27,  165,  225,  212,   27,  149,  263,   27,
   26,  204,  318,   26,  204,  205,   79,  202,  205,  157,
   84,  203,  133,  177,  129,  133,   16,  133,  215,  177,
  192,  327,  133,  136,  164,   27,  129,  136,  193,  224,
   27,  213,   27,  213,  133,  149,  305,  242,   89,   26,
  300,  300,   27,   16,  310,    6,  129,  213,  268,   62,
  177,  180,   38,  102,  133,  190,  258,  259,  260,   27,
  136,   41,   27,   26,  204,  180,   62,   67,  205,  302,
  202,  150,  134,  134,  203,  141,  313,  186,  285,  180,
  180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
  180,  180,  180,  180,   74,   48,  230,  232,   62,  321,
  156,  134,   62,  320,  134,  180,  134,    3,   49,  150,
  134,  134,  187,  141,  171,  229,  267,  171,  325,    4,
    5,   62,  293,  134,  180,  180,   74,  331,  180,  172,
   74,  189,  172,  311,  312,  306,  307,  180,  180,   74,
   74,   74,   74,  134,   74,   74,   74,  178,   74,   74,
  315,  180,  180,  180,  180,  180,  180,  180,  180,  180,
  180,  180,  180,  180,  180,  180,  187,    6,   42,  231,
  173,  237,  186,  189,  116,  117,   51,  180,  178,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   43,   44,  180,  180,  173,   64,
  180,  173,  118,  119,  237,   71,  238,  187,  187,  284,
  180,  120,   65,  240,  162,   79,  121,  162,  164,  116,
  117,  164,  240,   37,   37,  158,  297,  174,  169,  122,
  123,  124,  125,  126,  127,  128,  129,  130,  170,  238,
  131,  132,  133,  134,  135,  136,  137,  118,  238,  162,
   14,  286,   37,  164,   52,  174,  120,  238,  174,   22,
  158,  121,   75,   14,  116,  117,   74,    6,   37,  144,
  144,  324,   22,  144,  122,  123,  124,  125,  126,  127,
  128,  129,   52,   46,   44,  131,  132,  133,  134,  135,
  136,  137,  118,  272,   75,  279,  329,  280,   75,  330,
  277,  120,  200,  201,  202,  203,  121,   75,   75,   75,
   75,   54,   75,   75,   75,   69,   75,   75,   71,  122,
  123,  124,  125,  126,  127,  128,  129,   52,   43,   74,
  131,  132,  133,  134,  135,  136,  137,   97,   98,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   76,   45,   77,  209,  210,   81,
   43,   78,  211,   43,   43,   43,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,  204,  205,  206,   43,  198,  199,   45,   43,   63,
   44,   45,   45,  249,  250,  251,  252,   90,   43,  213,
  213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
   95,   45,  253,  254,  255,   45,  207,  208,   52,   54,
  247,  248,   84,   89,  206,   45,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,  256,  257,   92,  213,  112,  115,  113,  114,  162,
  168,  175,   42,  191,  176,  185,  194,  195,  213,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
  196,   42,  214,  197,  218,   42,  233,  219,  236,  239,
  221,   72,  261,  266,  272,   42,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  277,  278,  112,
  281,  287,  112,  112,  288,  289,  290,  112,  112,  112,
  291,  292,   37,   72,  296,  309,  295,   72,   84,  304,
  317,   44,  109,  109,  109,  322,   72,   72,  109,  109,
  109,   72,   72,   72,  112,   72,   72,  112,  112,  112,
  112,  112,  112,  112,  112,  215,  112,  112,  112,  112,
   70,  112,  112,  112,  109,  112,  328,  155,  109,  109,
  109,  109,  109,  109,  109,  109,  175,  109,  109,  109,
  109,   86,  109,  109,  109,  176,  109,  109,   86,   86,
   52,  131,   70,   55,  207,  211,   70,  181,  241,  243,
  245,  314,   87,  244,  246,   70,   70,  308,  103,   87,
   87,   70,   70,   86,   70,   70,  104,   86,   86,   86,
   86,   86,   86,   86,   86,  111,   86,   86,   86,   86,
   82,   86,   86,   86,   87,   86,   86,  105,   87,   87,
   87,   87,   87,   87,   87,   87,  262,   87,   87,   87,
   87,   88,   87,   87,   87,  173,   87,   87,   88,   88,
  217,  167,   82,  100,   99,   80,   82,   82,   82,   82,
   82,   82,   82,   82,  316,   82,   82,   82,   82,   83,
   82,   82,   82,   88,   82,   82,    0,   88,   88,   88,
   88,   88,   88,   88,   88,    0,   88,   88,   88,   88,
   85,   88,   88,   88,    0,   88,   88,    0,    0,    0,
    0,   83,    0,    0,    0,   83,   83,   83,   83,   83,
   83,   83,   83,    0,   83,   83,   83,   83,   84,   83,
   83,   83,   85,   83,   83,    0,   85,   85,   85,   85,
   85,   85,   85,   85,    0,   85,   85,   85,   85,   77,
   85,   85,   85,    0,   85,   85,    0,    0,    0,    0,
   84,    0,    0,    0,   84,   84,   84,   84,   84,   84,
   84,   84,    0,   84,   84,   84,   84,   80,   84,   84,
   84,   77,   84,   84,    0,   77,   77,   77,   77,   77,
    0,    0,    0,    0,   77,   77,   77,   77,   81,   77,
   77,   77,    0,   77,   77,    0,    0,    0,    0,   80,
    0,    0,    0,   80,   80,   80,   80,   80,    0,   78,
    0,    0,   80,   80,   80,   80,    0,   80,   80,   80,
   81,   80,   80,    0,   81,   81,   81,   81,   81,    0,
   79,    0,    0,   81,   81,   81,   81,    0,   81,   81,
   81,   78,   81,   81,    0,   78,   78,   78,   78,   78,
    0,   76,    0,    0,   78,   78,   78,   78,    0,   78,
   78,   78,   79,   78,   78,    0,   79,   79,   79,   79,
   79,    0,   73,    0,    0,   79,   79,   79,   79,    0,
   79,   79,   79,   76,   79,   79,    0,   76,    0,   71,
    0,    0,    0,    0,    0,    0,   76,   76,   76,   76,
   68,   76,   76,   76,   73,   76,   76,    0,   73,    0,
    0,    0,    0,    0,    0,    0,   69,   73,   73,    0,
    0,   71,   73,   73,   73,   71,   73,   73,   66,    0,
    0,    0,   68,   67,   71,   71,   68,    0,    0,    0,
   71,   71,    0,   71,   71,   68,   68,    0,   69,   64,
    0,   68,   69,    0,   68,   68,    0,    0,    0,    0,
   66,   69,   69,    0,   66,   67,   65,   69,    0,   67,
   69,   69,    0,   66,   66,    0,    0,    0,   67,   67,
    0,   64,   66,   66,    0,   64,    0,   67,   67,    0,
    0,    0,    0,    0,    0,   64,    0,    0,   65,    0,
  109,  109,   65,   64,   64,  109,  109,  109,    0,    0,
    0,    0,   65,    0,    0,    0,    0,    0,    0,    0,
   65,   65,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  109,  109,  109,  109,
  109,  109,  109,    0,  109,  109,  109,  109,    0,  109,
  109,  109,    0,  109,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   42,
   42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,    0,    0,    0,    0,  118,    0,
    0,    0,    0,    0,    0,    0,    0,  120,    0,   37,
    0,    0,  121,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   42,  122,  123,  124,  125,  126,
  127,  128,  129,   52,    0,    0,  131,  132,  133,  134,
  135,  136,  137,
};
}
static short yycheck[];
static { yycheck(); }
static void yycheck() {
yycheck = new short[] {                          5,
   13,  105,  118,  116,  117,   67,  172,  120,  121,  185,
   37,  219,   18,    2,  257,  259,  260,  257,  257,  221,
  261,  260,  258,  259,  260,  257,  260,  274,  258,  229,
  282,  259,  260,   95,  314,  260,  257,  260,  214,  260,
  257,  257,  302,  260,  260,  257,   59,  257,  260,  292,
  330,  257,  288,  115,  298,  291,  330,  293,  162,  260,
  306,  321,  298,  293,  298,  293,  310,  297,  314,  173,
  298,  296,  293,  316,  310,  298,  278,  193,  330,  296,
  320,  320,  310,  330,  284,  317,  330,  330,  296,  330,
  291,  118,  105,   82,  330,  139,  209,  210,  211,  320,
  330,  291,  330,  320,  320,  257,  260,  288,  320,  275,
  320,  260,  259,  260,  320,  260,  292,  258,  231,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  260,  319,  180,  181,  292,  305,
  292,  288,  296,  303,  291,  297,  293,  257,  332,  298,
  297,  298,  293,  298,  288,  296,  218,  291,  318,  269,
  270,  315,  266,  310,  316,  317,  292,  327,  320,  288,
  296,  258,  291,  286,  290,  279,  280,  257,  330,  305,
  306,  307,  308,  330,  310,  311,  312,  260,  314,  315,
  294,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  293,  317,  291,  296,
  260,  258,  258,  258,  267,  268,  330,  297,  291,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  257,  258,  316,  317,  288,  318,
  320,  291,  295,  296,  258,  297,  293,  293,  293,  296,
  330,  304,  331,  258,  257,  268,  309,  260,  257,  267,
  268,  260,  258,  316,  316,  257,  272,  260,  320,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  330,  293,
  333,  334,  335,  336,  337,  338,  339,  295,  293,  292,
  318,  296,  316,  292,  330,  288,  304,  293,  291,  318,
  292,  309,  260,  331,  267,  268,  330,  317,  316,  287,
  288,  317,  331,  291,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  257,  258,  333,  334,  335,  336,  337,
  338,  339,  295,  286,  292,  287,  323,  289,  296,  326,
  293,  304,  297,  298,  299,  300,  309,  305,  306,  307,
  308,  330,  310,  311,  312,  258,  314,  315,  297,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  260,  330,
  333,  334,  335,  336,  337,  338,  339,  320,  321,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  292,  260,  257,  261,  262,  292,
  292,  260,  266,  295,  296,  297,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  301,  302,  303,  316,  307,  308,  292,  320,  257,
  258,  296,  297,  200,  201,  202,  203,  295,  330,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  287,  316,  204,  205,  206,  320,  267,  268,  291,  292,
  198,  199,  330,  330,  296,  330,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  207,  208,  330,  316,  297,  260,  258,  258,  287,
  320,  330,  297,  296,  330,  263,  305,  311,  330,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  312,  316,  291,  310,  260,  320,  296,  295,  294,  282,
  330,  260,  330,  310,  286,  330,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  293,  330,  258,
  260,  282,  261,  262,  294,  282,  315,  266,  267,  268,
  292,  260,  316,  292,  260,  298,  296,  296,  330,  294,
  260,  258,  260,  261,  262,  259,  305,  306,  266,  267,
  268,  310,  311,  312,  293,  314,  315,  296,  297,  298,
  299,  300,  301,  302,  303,  330,  305,  306,  307,  308,
  260,  310,  311,  312,  292,  314,  330,  292,  296,  297,
  298,  299,  300,  301,  302,  303,  291,  305,  306,  307,
  308,  260,  310,  311,  312,  291,  314,  315,  267,  268,
  291,  298,  292,  292,  296,  330,  296,  118,  192,  194,
  196,  294,  260,  195,  197,  305,  306,  281,   82,  267,
  268,  311,  312,  292,  314,  315,   82,  296,  297,  298,
  299,  300,  301,  302,  303,   83,  305,  306,  307,  308,
  260,  310,  311,  312,  292,  314,  315,   82,  296,  297,
  298,  299,  300,  301,  302,  303,  212,  305,  306,  307,
  308,  260,  310,  311,  312,  105,  314,  315,  267,  268,
  163,   96,  292,   78,   77,   59,  296,  297,  298,  299,
  300,  301,  302,  303,  296,  305,  306,  307,  308,  260,
  310,  311,  312,  292,  314,  315,   -1,  296,  297,  298,
  299,  300,  301,  302,  303,   -1,  305,  306,  307,  308,
  260,  310,  311,  312,   -1,  314,  315,   -1,   -1,   -1,
   -1,  292,   -1,   -1,   -1,  296,  297,  298,  299,  300,
  301,  302,  303,   -1,  305,  306,  307,  308,  260,  310,
  311,  312,  292,  314,  315,   -1,  296,  297,  298,  299,
  300,  301,  302,  303,   -1,  305,  306,  307,  308,  260,
  310,  311,  312,   -1,  314,  315,   -1,   -1,   -1,   -1,
  292,   -1,   -1,   -1,  296,  297,  298,  299,  300,  301,
  302,  303,   -1,  305,  306,  307,  308,  260,  310,  311,
  312,  292,  314,  315,   -1,  296,  297,  298,  299,  300,
   -1,   -1,   -1,   -1,  305,  306,  307,  308,  260,  310,
  311,  312,   -1,  314,  315,   -1,   -1,   -1,   -1,  292,
   -1,   -1,   -1,  296,  297,  298,  299,  300,   -1,  260,
   -1,   -1,  305,  306,  307,  308,   -1,  310,  311,  312,
  292,  314,  315,   -1,  296,  297,  298,  299,  300,   -1,
  260,   -1,   -1,  305,  306,  307,  308,   -1,  310,  311,
  312,  292,  314,  315,   -1,  296,  297,  298,  299,  300,
   -1,  260,   -1,   -1,  305,  306,  307,  308,   -1,  310,
  311,  312,  292,  314,  315,   -1,  296,  297,  298,  299,
  300,   -1,  260,   -1,   -1,  305,  306,  307,  308,   -1,
  310,  311,  312,  292,  314,  315,   -1,  296,   -1,  260,
   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,  307,  308,
  260,  310,  311,  312,  292,  314,  315,   -1,  296,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  260,  305,  306,   -1,
   -1,  292,  310,  311,  312,  296,  314,  315,  260,   -1,
   -1,   -1,  292,  260,  305,  306,  296,   -1,   -1,   -1,
  311,  312,   -1,  314,  315,  305,  306,   -1,  292,  260,
   -1,  311,  296,   -1,  314,  315,   -1,   -1,   -1,   -1,
  292,  305,  306,   -1,  296,  292,  260,  311,   -1,  296,
  314,  315,   -1,  305,  306,   -1,   -1,   -1,  305,  306,
   -1,  292,  314,  315,   -1,  296,   -1,  314,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  306,   -1,   -1,  292,   -1,
  261,  262,  296,  314,  315,  266,  267,  268,   -1,   -1,
   -1,   -1,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  314,  315,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  297,  298,  299,  300,
  301,  302,  303,   -1,  305,  306,  307,  308,   -1,  310,
  311,  312,   -1,  314,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,   -1,   -1,   -1,   -1,  295,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  304,   -1,  316,
   -1,   -1,  309,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  316,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,  333,  334,  335,  336,
  337,  338,  339,
};
}
final static short YYFINAL=1;
final static short YYMAXTOKEN=339;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"SEMI","DOT","DOTDOTDOT","COMMA","STAR","PERCENT","EQUALS",
"ANNOSTRING","ANNOCHAR","SLASH","PLUS","MINUS","PACKAGE","IMPORT","PUBLIC",
"PROTECTED","PRIVATE","STATIC","FINAL","ABSTRACT","NATIVE","STRICTFP",
"SYNCHRONIZED","TRANSIENT","VOLATILE","CLASS","INTERFACE","ENUM",
"ANNOINTERFACE","THROWS","EXTENDS","IMPLEMENTS","SUPER","DEFAULT","BRACEOPEN",
"BRACECLOSE","SQUAREOPEN","SQUARECLOSE","PARENOPEN","PARENCLOSE","LESSTHAN",
"GREATERTHAN","LESSEQUALS","GREATEREQUALS","LESSTHAN2","GREATERTHAN2",
"GREATERTHAN3","EXCLAMATION","AMPERSAND2","VERTLINE2","EQUALS2","NOTEQUALS",
"TILDE","AMPERSAND","VERTLINE","CIRCUMFLEX","VOID","QUERY","COLON","AT",
"JAVADOCSTART","JAVADOCEND","JAVADOCEOL","CODEBLOCK","PARENBLOCK","BYTE",
"SHORT","INT","LONG","CHAR","FLOAT","DOUBLE","BOOLEAN","IDENTIFIER",
"JAVADOCTAG","JAVADOCTOKEN","BOOLEAN_LITERAL","INTEGER_LITERAL","LONG_LITERAL",
"FLOAT_LITERAL","DOUBLE_LITERAL","CHAR_LITERAL","STRING_LITERAL",
};
final static String yyrule[] = {
"$accept : file",
"file :",
"$$1 :",
"file : file $$1 filepart",
"filepart : package",
"filepart : import",
"filepart : javadoc",
"filepart : class",
"filepart : enum",
"filepart : SEMI",
"package : PACKAGE fullidentifier SEMI",
"import : IMPORT fullidentifier SEMI",
"import : IMPORT STATIC fullidentifier SEMI",
"javadoc : JAVADOCSTART javadocdescription javadoctags JAVADOCEND",
"javadocdescription : javadoctokens",
"javadoctokens :",
"javadoctokens : javadoctokens javadoctoken",
"javadoctoken : JAVADOCTOKEN",
"javadoctoken : JAVADOCEOL",
"javadoctags :",
"javadoctags : javadoctags javadoctag",
"$$2 :",
"javadoctag : JAVADOCTAG $$2 javadoctokens",
"fullidentifier : IDENTIFIER",
"fullidentifier : fullidentifier DOT IDENTIFIER",
"fullidentifier : fullidentifier DOT STAR",
"arrayidentifier : IDENTIFIER dimensions",
"dimensions :",
"dimensions : dimensions SQUAREOPEN SQUARECLOSE",
"modifier : PUBLIC",
"modifier : PROTECTED",
"modifier : PRIVATE",
"modifier : STATIC",
"modifier : FINAL",
"modifier : ABSTRACT",
"modifier : NATIVE",
"modifier : SYNCHRONIZED",
"modifier : VOLATILE",
"modifier : TRANSIENT",
"modifier : STRICTFP",
"modifiers : modifiers modifier",
"modifiers : modifiers annotation",
"modifiers :",
"$$3 :",
"annotation : AT name $$3 annotationParensOpt",
"annotationParensOpt :",
"annotationParensOpt : PARENOPEN value PARENCLOSE",
"annotationParensOpt : PARENOPEN valuePairs PARENCLOSE",
"annotationParensOpt : PARENOPEN PARENCLOSE",
"valuePairs : valuePair",
"valuePairs : valuePairs COMMA valuePair",
"valuePair : IDENTIFIER EQUALS value",
"$$4 :",
"arrayInitializer : $$4 BRACEOPEN valuesOpt BRACECLOSE",
"valuesOpt :",
"valuesOpt : values",
"values : value",
"values : values COMMA value",
"value : expression",
"value : annotation",
"value : arrayInitializer",
"expression : conditionalExpression",
"conditionalExpression : conditionalOrExpression",
"conditionalExpression : conditionalOrExpression QUERY expression COLON expression",
"conditionalOrExpression : conditionalAndExpression",
"conditionalOrExpression : conditionalOrExpression VERTLINE2 conditionalAndExpression",
"conditionalAndExpression : inclusiveOrExpression",
"conditionalAndExpression : conditionalAndExpression AMPERSAND2 inclusiveOrExpression",
"inclusiveOrExpression : exclusiveOrExpression",
"inclusiveOrExpression : inclusiveOrExpression VERTLINE exclusiveOrExpression",
"exclusiveOrExpression : andExpression",
"exclusiveOrExpression : exclusiveOrExpression CIRCUMFLEX andExpression",
"andExpression : equalityExpression",
"andExpression : andExpression AMPERSAND equalityExpression",
"equalityExpression : relationalExpression",
"equalityExpression : equalityExpression EQUALS2 relationalExpression",
"equalityExpression : equalityExpression NOTEQUALS relationalExpression",
"relationalExpression : shiftExpression",
"relationalExpression : relationalExpression LESSEQUALS shiftExpression",
"relationalExpression : relationalExpression GREATEREQUALS shiftExpression",
"relationalExpression : relationalExpression LESSTHAN shiftExpression",
"relationalExpression : relationalExpression GREATERTHAN shiftExpression",
"shiftExpression : additiveExpression",
"shiftExpression : shiftExpression LESSTHAN2 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN3 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN2 additiveExpression",
"additiveExpression : multiplicativeExpression",
"additiveExpression : additiveExpression PLUS multiplicativeExpression",
"additiveExpression : additiveExpression MINUS multiplicativeExpression",
"multiplicativeExpression : unaryExpression",
"multiplicativeExpression : multiplicativeExpression STAR unaryExpression",
"multiplicativeExpression : multiplicativeExpression SLASH unaryExpression",
"multiplicativeExpression : multiplicativeExpression PERCENT unaryExpression",
"unaryExpression : PLUS unaryExpression",
"unaryExpression : MINUS unaryExpression",
"unaryExpression : unaryExpressionNotPlusMinus",
"unaryExpressionNotPlusMinus : TILDE unaryExpression",
"unaryExpressionNotPlusMinus : EXCLAMATION unaryExpression",
"unaryExpressionNotPlusMinus : primary",
"primary : PARENOPEN primitiveType PARENCLOSE unaryExpression",
"primary : PARENOPEN primitiveType dims PARENCLOSE unaryExpression",
"primary : PARENOPEN name dims PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN name PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN expression PARENCLOSE",
"primary : literal",
"primary : primitiveType dims DOT CLASS",
"primary : primitiveType DOT CLASS",
"primary : name DOT CLASS",
"primary : name dims DOT CLASS",
"primary : name",
"dims : SQUAREOPEN SQUARECLOSE",
"dims : dims SQUAREOPEN SQUARECLOSE",
"name : IDENTIFIER",
"name : name DOT IDENTIFIER",
"literal : DOUBLE_LITERAL",
"literal : FLOAT_LITERAL",
"literal : LONG_LITERAL",
"literal : INTEGER_LITERAL",
"literal : BOOLEAN_LITERAL",
"literal : CHAR_LITERAL",
"literal : STRING_LITERAL",
"primitiveType : BOOLEAN",
"primitiveType : BYTE",
"primitiveType : SHORT",
"primitiveType : INT",
"primitiveType : LONG",
"primitiveType : CHAR",
"primitiveType : FLOAT",
"primitiveType : DOUBLE",
"type : classtype dimensions",
"$$5 :",
"$$6 :",
"classtype : typedeclspecifier LESSTHAN $$5 typearglist $$6 GREATERTHAN",
"classtype : typedeclspecifier",
"typedeclspecifier : typename",
"typedeclspecifier : classtype DOT IDENTIFIER",
"typename : IDENTIFIER",
"typename : typename DOT IDENTIFIER",
"typearglist : typearg",
"typearglist : typearglist COMMA typearg",
"typearg : type",
"typearg : QUERY",
"typearg : QUERY EXTENDS type",
"typearg : QUERY SUPER type",
"opt_typeparams :",
"opt_typeparams : typeparams",
"typeparams : LESSTHAN typeparamlist GREATERTHAN",
"typeparamlist : typeparam",
"typeparamlist : typeparamlist COMMA typeparam",
"typeparam : IDENTIFIER",
"typeparam : IDENTIFIER EXTENDS typeboundlist",
"typeboundlist : type",
"typeboundlist : typeboundlist AMPERSAND type",
"enum : enum_definition BRACEOPEN enum_body BRACECLOSE",
"enum_definition : modifiers ENUM IDENTIFIER opt_implements",
"enum_body : enum_values",
"enum_body : enum_values SEMI members",
"enum_values :",
"enum_values : enum_value",
"enum_values : enum_value COMMA enum_values",
"enum_value : javadoc enum_constructor",
"enum_value : opt_annotations enum_constructor",
"enum_constructor : IDENTIFIER",
"enum_constructor : IDENTIFIER CODEBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK CODEBLOCK",
"class : classdefinition BRACEOPEN members BRACECLOSE",
"classdefinition : modifiers classorinterface IDENTIFIER opt_typeparams opt_extends opt_implements",
"classorinterface : CLASS",
"classorinterface : INTERFACE",
"classorinterface : ANNOINTERFACE",
"opt_extends :",
"opt_extends : EXTENDS extendslist",
"extendslist : classtype",
"extendslist : extendslist COMMA classtype",
"opt_implements :",
"opt_implements : IMPLEMENTS implementslist",
"implementslist : classtype",
"implementslist : implementslist COMMA classtype",
"members :",
"$$7 :",
"members : members $$7 member",
"member : javadoc",
"member : fields",
"member : method",
"member : constructor",
"member : static_block",
"member : class",
"member : enum",
"member : SEMI",
"memberend : SEMI",
"memberend : CODEBLOCK",
"static_block : modifiers CODEBLOCK",
"$$8 :",
"fields : modifiers type arrayidentifier $$8 extrafields memberend",
"extrafields :",
"$$9 :",
"extrafields : extrafields COMMA $$9 arrayidentifier",
"method : modifiers typeparams type IDENTIFIER methoddef dimensions opt_exceptions memberend",
"method : modifiers type IDENTIFIER methoddef dimensions opt_exceptions memberend",
"constructor : modifiers IDENTIFIER methoddef opt_exceptions memberend",
"methoddef : PARENOPEN opt_params PARENCLOSE",
"opt_exceptions :",
"opt_exceptions : THROWS exceptionlist",
"exceptionlist : fullidentifier",
"exceptionlist : exceptionlist COMMA fullidentifier",
"opt_params :",
"opt_params : paramlist",
"paramlist : param",
"paramlist : paramlist COMMA param",
"param : opt_annotations opt_parammodifiers type varargs arrayidentifier",
"varargs :",
"varargs : DOTDOTDOT",
"opt_annotations :",
"opt_annotations : opt_annotations annotation",
"opt_parammodifiers :",
"opt_parammodifiers : opt_parammodifiers modifier",
};

//#line 527 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"

private Lexer lexer;
private Builder builder;
private StringBuffer textBuffer = new StringBuffer();
private ClassDef cls = new ClassDef();
private MethodDef mth = new MethodDef();
private List annotationStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized 
private Annotation annotation = null;
private List annoValueListStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized
private List annoValueList = null;
private FieldDef param = new FieldDef();
private java.util.Set modifiers = new java.util.HashSet();
private TypeDef fieldType;
private Stack typeStack = new Stack();
private int line;
private int column;
private boolean debugLexer;

private void appendToBuffer(String word) {
    if (textBuffer.length() > 0) {
        char lastChar = textBuffer.charAt(textBuffer.length() - 1);
        if (!Character.isWhitespace(lastChar)) {
            textBuffer.append(' ');
        }
    }
    textBuffer.append(word);
}

private String buffer() {
    String result = textBuffer.toString().trim();
    textBuffer.setLength(0);
    return result;
}

public Parser(Lexer lexer, Builder builder) {
    this.lexer = lexer;
    this.builder = builder;
}

public void setDebugParser(boolean debug) {
    yydebug = debug;
}

public void setDebugLexer(boolean debug) {
    debugLexer = debug;
}

/**
 * Parse file. Return true if successful.
 */
public boolean parse() {
    return yyparse() == 0;
}

private int yylex() {
    try {
        final int result = lexer.lex();
        yylval = new Value();
        yylval.sval = lexer.text();
        if (debugLexer) {
            System.err.println("Token: " + yyname[result] + " \"" + yylval.sval + "\"");
        }
        return result;
    }
    catch(IOException e) {
        return 0;
    }
}

private void yyerror(String msg) {
    throw new ParseException(msg, lexer.getLine(), lexer.getColumn());
}

private class Value {
	Object oval;
    String sval;
    int ival;
	boolean bval;
    TypeDef type;
    AnnotationValue annoval;
}


private void makeField(TypeDef field, String body) {
    FieldDef fd = new FieldDef();
    fd.lineNumber = line;
    fd.modifiers.addAll(modifiers); 
    fd.name = field.name;
    fd.type = fieldType;
    fd.dimensions = field.dimensions;
    fd.body = body;
    builder.addField(fd);
}

private String convertString(String str) {
	StringBuffer buf = new StringBuffer();
	boolean escaped = false;
	int unicode = 0;
	int value = 0;
	int octal = 0;
	boolean consumed = false;
	
	for(int i = 0; i < str.length(); ++ i) {
		char ch = str.charAt( i );
		
		if(octal > 0) {
			if( value >= '0' && value <= '7' ) {
				value = ( value << 3 ) | Character.digit( ch, 8 );
				-- octal;
				consumed = true;
			}
			else {
				octal = 0;
			}
			
			if( octal == 0 ) {
				buf.append( (char) value );		
				value = 0;
			}
		}
		
		if(!consumed) {
			if(unicode > 0) {
				value = ( value << 4 ) | Character.digit( ch, 16 );
				
				-- unicode;
		
				if(unicode == 0) {
					buf.append( (char)value );
					value = 0;
				}
			}
			else if(ch == '\\') {
				escaped = true;
			}
			else if(escaped) {
				if(ch == 'u' || ch == 'U') {
					unicode = 4;
				}
				else if(ch >= '0' && ch <= '7') {
					octal = (ch > '3') ? 1 : 2;
					value = Character.digit( ch, 8 );
				}
				else {
					switch( ch ) {
						case 'b':
							buf.append('\b');
							break;
							
						case 'f':
							buf.append('\f');
							break;
							
						case 'n':
							buf.append('\n');
							break;
							
						case 'r':
							buf.append('\r');
							break;
							
						case 't':
							buf.append('\t');
							break;
							
						case '\'':
							buf.append('\'');
							break;
	
						case '\"':
							buf.append('\"');
							break;
	
						case '\\':
							buf.append('\\');
							break;
							
						default:
							yyerror( "Illegal escape character '" + ch + "'" );
					}
				}
				
				escaped = false;
			}
			else {
				buf.append( ch );
			}
		}
	}

	return buf.toString();
}

private Boolean toBoolean(String str) {
	str = str.trim();

	return new Boolean( str );
}

private Integer toInteger(String str) {
	str = str.trim();
	
	Integer result;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Integer( Integer.parseInt( str.substring( 2 ), 16 ) );
	}
	else if(str.length() > 1 && str.startsWith("0") ) {
		result = new Integer( Integer.parseInt( str.substring( 1 ), 8 ) );
	}
	else {
		result = new Integer( str );
	}
	
	return result;
}

private Long toLong(String str) {
	str = str.trim();

	Long result;
	
	if( !str.endsWith("l") && !str.endsWith("L") ) {
		yyerror( "Long literal must end with 'l' or 'L'." );
	}
	
	int len = str.length() - 1;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Long( Long.parseLong( str.substring( 2, len ), 16 ) );
	}
	else if(str.startsWith("0") ) {
		result = new Long( Long.parseLong( str.substring( 1, len ), 8 ) );
	}
	else {
		result = new Long( str.substring( 0, len ) );
	}

	return result;
}

private Float toFloat(String str) {
	str = str.trim();
	return new Float( str );
}

private Double toDouble(String str) {
	str = str.trim();

	if( !str.endsWith("d") && !str.endsWith("D") ) {
		yyerror( "Double literal must end with 'd' or 'D'." );
	}
	
	return new Double( str.substring( 0, str.length() - 1 ) );
}

/**
 * Convert a character literal into a character.
 */
private Character toChar(String str) {
	str = str.trim();

	if( !str.startsWith("'") && !str.endsWith("'") ) {
		yyerror("Character must be single quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	
	if( str2.length() != 1) {
		yyerror("Only one character allowed in character constants.");
	}
	
	return new Character( str2.charAt( 0 ) );
}

/**
 * Convert a string literal into a string.
 */
private String toString(String str) {
	str = str.trim();

	if( str.length() < 2 && !str.startsWith("\"") && !str.endsWith("\"") ) {
		yyerror("String must be double quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	return str2;
}
//#line 1151 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 2:
//#line 56 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 10:
//#line 62 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addPackage(val_peek(1).sval); }
break;
case 11:
//#line 65 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 12:
//#line 66 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 14:
//#line 74 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
        builder.addJavaDoc(buffer()); 
    }
break;
case 17:
//#line 81 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        appendToBuffer(val_peek(0).sval);
    }
break;
case 18:
//#line 84 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        textBuffer.append('\n');
    }
break;
case 21:
//#line 91 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 22:
//#line 92 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        builder.addJavaDocTag(new TagDef(val_peek(2).sval.substring(1), buffer(), line)); 
    }
break;
case 23:
//#line 101 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 24:
//#line 102 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 25:
//#line 103 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + ".*"; }
break;
case 26:
//#line 106 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival);
    }
break;
case 27:
//#line 111 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = 0; }
break;
case 28:
//#line 112 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.ival = val_peek(2).ival + 1; 
    }
break;
case 29:
//#line 118 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "public"; }
break;
case 30:
//#line 119 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "protected"; }
break;
case 31:
//#line 120 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "private"; }
break;
case 32:
//#line 121 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "static"; }
break;
case 33:
//#line 122 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "final"; }
break;
case 34:
//#line 123 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "abstract"; }
break;
case 35:
//#line 124 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "native"; }
break;
case 36:
//#line 125 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "synchronized"; }
break;
case 37:
//#line 126 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "volatile"; }
break;
case 38:
//#line 127 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "transient"; }
break;
case 39:
//#line 128 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "strictfp"; }
break;
case 40:
//#line 131 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ modifiers.add(val_peek(0).sval); }
break;
case 41:
//#line 132 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 43:
//#line 142 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
    	annotationStack.add(annotation);
    	annotation = new Annotation(builder.createType(val_peek(0).sval, 0), lexer.getLine()); 
    }
break;
case 44:
//#line 147 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	yyval.annoval = annotation;
    	annotation = (Annotation)annotationStack.remove(annotationStack.size() - 1);
    }
break;
case 46:
//#line 154 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annotation.setProperty("value", val_peek(1).annoval); }
break;
case 51:
//#line 163 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annotation.setProperty(val_peek(2).sval, val_peek(0).annoval); }
break;
case 52:
//#line 166 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	annoValueListStack.add(annoValueList);
    	annoValueList = new ArrayList(); 
    }
break;
case 53:
//#line 171 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	yyval.annoval = new AnnotationValueList(annoValueList);
    	annoValueList = (List)annoValueListStack.remove(annoValueListStack.size() - 1);
    }
break;
case 56:
//#line 181 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 57:
//#line 182 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 58:
//#line 185 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 59:
//#line 186 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 60:
//#line 187 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 61:
//#line 190 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 62:
//#line 193 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 63:
//#line 194 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationQuery(val_peek(4).annoval, val_peek(2).annoval, val_peek(0).annoval); }
break;
case 64:
//#line 197 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 65:
//#line 198 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 66:
//#line 201 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 67:
//#line 202 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 68:
//#line 205 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 69:
//#line 206 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 70:
//#line 209 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 71:
//#line 210 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationExclusiveOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 72:
//#line 213 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 73:
//#line 214 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 74:
//#line 217 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 75:
//#line 218 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 76:
//#line 219 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNotEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 77:
//#line 222 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 78:
//#line 223 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 79:
//#line 224 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 80:
//#line 225 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 81:
//#line 226 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 82:
//#line 229 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 83:
//#line 230 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftLeft(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 84:
//#line 231 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationUnsignedShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 85:
//#line 232 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 86:
//#line 235 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 87:
//#line 236 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAdd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 88:
//#line 237 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationSubtract(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 89:
//#line 240 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 90:
//#line 241 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMultiply(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 91:
//#line 242 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationDivide(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 92:
//#line 243 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationRemainder(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 93:
//#line 246 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationPlusSign(val_peek(0).annoval); }
break;
case 94:
//#line 247 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMinusSign(val_peek(0).annoval); }
break;
case 95:
//#line 248 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 96:
//#line 251 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNot(val_peek(0).annoval); }
break;
case 97:
//#line 252 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalNot(val_peek(0).annoval); }
break;
case 99:
//#line 256 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 100:
//#line 257 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 101:
//#line 258 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 102:
//#line 259 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 103:
//#line 260 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationParenExpression(val_peek(1).annoval); }
break;
case 104:
//#line 261 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 105:
//#line 262 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 106:
//#line 263 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 107:
//#line 264 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 108:
//#line 265 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 109:
//#line 266 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationFieldRef(val_peek(0).sval); }
break;
case 110:
//#line 269 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = 1; }
break;
case 111:
//#line 270 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = val_peek(2).ival + 1; }
break;
case 112:
//#line 273 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 113:
//#line 274 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + "." + val_peek(0).sval; }
break;
case 114:
//#line 277 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toDouble(val_peek(0).sval), val_peek(0).sval); }
break;
case 115:
//#line 278 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toFloat(val_peek(0).sval), val_peek(0).sval); }
break;
case 116:
//#line 279 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toLong(val_peek(0).sval), val_peek(0).sval); }
break;
case 117:
//#line 280 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toInteger(val_peek(0).sval), val_peek(0).sval); }
break;
case 118:
//#line 281 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toBoolean(val_peek(0).sval), val_peek(0).sval); }
break;
case 119:
//#line 282 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toChar(s), s); }
break;
case 120:
//#line 283 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toString(s), s); }
break;
case 121:
//#line 286 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "boolean"; }
break;
case 122:
//#line 287 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "byte"; }
break;
case 123:
//#line 288 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "short"; }
break;
case 124:
//#line 289 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "int"; }
break;
case 125:
//#line 290 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "long"; }
break;
case 126:
//#line 291 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "char"; }
break;
case 127:
//#line 292 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "float"; }
break;
case 128:
//#line 293 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "double"; }
break;
case 129:
//#line 299 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	TypeDef td = val_peek(1).type;
    	td.dimensions = val_peek(0).ival;
        yyval.type = td;
    }
break;
case 130:
//#line 306 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    		TypeDef td = new TypeDef(val_peek(1).sval,0);
    		td.actualArgumentTypes = new ArrayList();
    		yyval.type = (TypeDef) typeStack.push(td);
    	}
break;
case 131:
//#line 310 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
    		yyval.type = (TypeDef) typeStack.pop();
    	}
break;
case 132:
//#line 312 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
         yyval.type = val_peek(1).type;
    }
break;
case 133:
//#line 315 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(0).sval,0); 
    }
break;
case 134:
//#line 320 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 135:
//#line 321 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).type.name + '.' + val_peek(0).sval; }
break;
case 136:
//#line 324 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 137:
//#line 325 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 138:
//#line 328 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 139:
//#line 329 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 140:
//#line 332 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = val_peek(0).type;}
break;
case 141:
//#line 333 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef();}
break;
case 142:
//#line 334 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "extends");}
break;
case 143:
//#line 335 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "super");}
break;
case 153:
//#line 355 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
  builder.endClass();
  fieldType = null;
  modifiers.clear();
}
break;
case 154:
//#line 361 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    cls.lineNumber = line;
    cls.modifiers.addAll(modifiers);
    cls.name = val_peek(1).sval;
    cls.type = ClassDef.ENUM;
    builder.beginClass(cls);
    cls = new ClassDef();
    fieldType = new TypeDef(val_peek(1).sval, 0);
}
break;
case 162:
//#line 380 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(0).sval, 0), ""); }
break;
case 163:
//#line 381 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 164:
//#line 382 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 165:
//#line 383 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(2).sval, 0), ""); }
break;
case 166:
//#line 389 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        builder.endClass(); 
    }
break;
case 167:
//#line 394 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        cls.lineNumber = line;
        cls.modifiers.addAll(modifiers); modifiers.clear(); 
        cls.name = val_peek(3).sval;
        builder.beginClass(cls); 
        cls = new ClassDef(); 
    }
break;
case 168:
//#line 403 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.CLASS; }
break;
case 169:
//#line 404 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.INTERFACE; }
break;
case 170:
//#line 405 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.ANNOTATION_TYPE; }
break;
case 173:
//#line 410 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 174:
//#line 411 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 177:
//#line 416 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 178:
//#line 417 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 180:
//#line 419 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 190:
//#line 432 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
      yyval.sval = "";
    }
break;
case 191:
//#line 435 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
	  yyval.sval = lexer.getCodeBody();
    }
break;
case 192:
//#line 440 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ lexer.getCodeBody(); modifiers.clear(); }
break;
case 193:
//#line 445 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        fieldType = val_peek(1).type;
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 194:
//#line 449 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        modifiers.clear();
    }
break;
case 196:
//#line 454 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 197:
//#line 454 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 198:
//#line 462 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.returnType = val_peek(5).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 199:
//#line 472 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear();
        mth.returnType = val_peek(5).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef();
    }
break;
case 200:
//#line 484 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.constructor = true; mth.name = val_peek(3).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 204:
//#line 498 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 205:
//#line 499 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 210:
//#line 508 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        param.name = val_peek(0).type.name;
        param.type = val_peek(2).type;
        param.dimensions = val_peek(0).type.dimensions;
        param.isVarArgs = val_peek(1).bval;
        mth.params.add(param);
        param = new FieldDef();
    }
break;
case 211:
//#line 518 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.bval = false; }
break;
case 212:
//#line 519 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.bval = true; }
break;
case 216:
//#line 524 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ param.modifiers.add(val_peek(0).sval); }
break;
//#line 2011 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      if (yydebug) debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      if (yydebug) debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
//## The -Jnoconstruct option was used ##
//###############################################################



}
//################### END OF CLASS ##############################
